function [v, index] = kmean(x, c)

m = mean(x, 2);
p = size(x, 1);
q = size(x, 2);

t = rand(p,c)-0.5;
v = kron(m, ones(1,c)) + t;
vv = v;
maxv = 10e50;

e = 0.01;
while (maxv>e)
    
    D = zeros(1,q);
    for i=1:q
        y = kron(x(:,i), ones(1,c)) - v;
        s = sum(y.^2, 1);
        [C, I] = min(s');
        D(i) = I;
    end

    for i=1:c
        T = find(D==i);
        vv(:,i) = mean(x(:,T),2);
    end
    maxv = max(sqrt(sum((vv - v).^2, 1)));
    v = vv;
end

index = D;
